;
; Copyright (c) 2001-2004 Vaclav Slavik
; 
; Permission is hereby granted, free of charge, to any person obtaining a copy
; of this software and associated documentation files (the "Software"), to
; deal in the Software without restriction, including without limitation the
; rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
; sell copies of the Software, and to permit persons to whom the Software is
; furnished to do so, subject to the following conditions:
; 
; The above copyright notice and this permission notice shall be included in
; all copies or substantial portions of the Software.
; 
; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
; FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
; IN THE SOFTWARE. 
;
; $Id: mslu0008.asm 91 2008-07-30 10:56:19Z vaclavslavik $

%include "dll_names.inc"

%ifdef DIGITALMARS
                    group FLAT _TEXT _DATA
    ; DM is otherwise same as Borland:
    %define BORLAND 1
%endif

                    global __imp__WNetDisconnectDialog1W@4
                    global WNetDisconnectDialog1W
                    global _WNetDisconnectDialog1W@4
                    global _Unicows_WNetDisconnectDialog1W
                  
                    extern _LoadUnicowsSymbol

%ifdef BORLAND
                    section  _TEXT class=CODE code  use32
%else
                    section .text
%endif

unicows_initial_stub_WNetDisconnectDialog1W:
                    ; Load the symbol...
                    pusha
                    push dword __imp__WNetDisconnectDialog1W@4     ; place to save the pointer
                    push dword [_Unicows_WNetDisconnectDialog1W]      ; default proc, if any
                    push dword MPR                  ; dll id
                    push dword namestring_WNetDisconnectDialog1W      ; name of the function
                    call _LoadUnicowsSymbol
                    add  esp,byte 16
                    popa

                    ; ...and skip to it (see following jmp instruction):

WNetDisconnectDialog1W:
_WNetDisconnectDialog1W@4:
                    jmp [__imp__WNetDisconnectDialog1W@4]

%ifdef BORLAND
                    section  _DATA class=DATA data use32
%else
                    section .data
%endif

__imp__WNetDisconnectDialog1W@4:   dd unicows_initial_stub_WNetDisconnectDialog1W
_Unicows_WNetDisconnectDialog1W:      dd 0
namestring_WNetDisconnectDialog1W:    db 'WNetDisconnectDialog1W',0
